<script lang="ts" setup>
import type { BaseCard } from '@/types/base';

interface Copy extends BaseCard {
  config?: BaseCard['config'] & {
    aosAnimation?: string;
    aosDuration?: string;
    id?: string;
    hasHorizontalRule?: boolean;
    noMarginBottom?: boolean;
    alignCenter?: boolean;
    metadataId?: string;
    subtitleMobilePadding?: boolean;
  };
}

defineProps<Copy>();
</script>

<template>
  <SlpContainer
    :id="config?.id"
    :data-aos="config?.aosAnimation"
    :data-aos-duration="config?.aosDuration"
    :class="[
      {
        'slp-mb-64': config?.hasHorizontalRule && !config?.noMarginBottom,
      },
    ]"
  >
    <span
      v-if="config?.metadataId"
      :id="config?.metadataId"
      class="slp-position-absolute"
      :data-slippers-scroll="config?.metadataId"
    />
    <SlpRow class="copy" :class="[{ 'copy__align_center header': config?.alignCenter }]">
      <SlpColumn>
        <SlpTypography
          v-if="header"
          :id="config?.id ?? toKebabCase(header)"
          variant="heading3"
          tag="h2"
          class="slp-mb-8 slp-mt-8"
          >{{ header }}</SlpTypography
        >
        <SlpTypography
          v-if="subTitle"
          tag="h3"
          variant="heading4"
          class="copy__subtitle"
          :class="{
            'copy__subtitle--mobile--padding': config?.subtitleMobilePadding,
          }"
          >{{ subTitle }}</SlpTypography
        >
        <div v-if="text" class="copy__body slp-mb-32" v-html="$md.render(text)" />

        <SlpButton
          v-if="button"
          :href="button.config.href"
          :data-ga-name="button.config.dataGaName"
          :data-ga-location="button.config.dataGaLocation"
        >
          {{ button.text }}
        </SlpButton>
      </SlpColumn>
      <CommonHorizontalRule v-if="config?.hasHorizontalRule" />
    </SlpRow>
  </SlpContainer>
</template>

<style lang="scss" scoped>
.copy {
  grid-column: 1 / span 12;

  @media (min-width: $breakpoint-lg) {
    grid-column: 1 / span 12;
  }

  &__subtitle {
    @media (max-width: $breakpoint-lg) {
      &--mobile--padding {
        padding: 0 $spacing-16 $spacing-64 $spacing-16;
      }
    }
  }

  h4 {
    color: $color-text-300;
    font-size: 19px;
    font-weight: 400;
    line-height: 20px;
    margin-bottom: 16px;

    @media (min-width: $breakpoint-lg) {
      font-size: 23px;
      line-height: 28px;
    }
  }

  h3,
  &__body :deep(h3) {
    font-size: 23px;
    line-height: 28px;

    @media (max-width: $breakpoint-sm) {
      font-size: 19px;
      line-height: 24px;
    }
  }

  h2,
  &__body :deep(h2) {
    font-size: 36px;
    line-height: 40px;
  }

  &__body {
    grid-column: 1 / -1;
    color: $color-text-300;

    &:deep(p) {
      margin-bottom: 1em;
      font-size: 16px;
    }

    &:deep(li) {
      font-size: 16px;
    }

    &:deep(ul) {
      margin-left: $spacing-32;
    }

    & :deep(p a) {
      color: $color-text-link-100;
    }

    &:deep(h3) {
      margin-top: $spacing-32;
      margin-bottom: $spacing-8;
    }

    &:deep(blockquote) {
      display: block;
      padding: 10px;
      margin: 0 0 10px;
      word-break: break-all;
      word-wrap: break-word;
      background-color: #f5f5f5;
      border: 1px solid #ccc;
      border-radius: 4px;
    }

    p,
    h4,
    li {
      font-size: 14px;
      line-height: 1.42857;
      color: #333;
    }

    h4 {
      margin-bottom: $spacing-32;
    }

    p {
      margin-bottom: unset;
    }

    &:deep(table) {
      table-layout: fixed;
      width: 100%;
      max-width: 100%;
      margin-bottom: 20px;
      background-color: transparent;
      border-collapse: collapse;
      border-spacing: 0;

      & > thead {
        &:first-child > :first-child > th {
          border-top: 1px solid $color-surface-200;
        }

        & > tr > th {
          vertical-align: bottom;
          padding: 8px;
          line-height: 1.42857;
          border: 1px solid $color-surface-200;
          border-bottom: 2px solid $color-surface-200;
        }
      }

      td {
        padding: 8px;
        line-height: 1.42857;
        vertical-align: top;
        border: 1px solid $color-surface-200;
        font-size: $text-body-1;
      }
    }
  }

  &__align_center {
    text-align: center;
  }
}

.header {
  color: $color-text-300;
  margin-bottom: $spacing-16;
}
</style>
